package com.ruoyi.scientific.service;

import com.ruoyi.scientific.domain.ProjectApplication;
import com.ruoyi.scientific.domain.bo.FundsReceivedBo;
import com.ruoyi.scientific.domain.vo.ProjectApplicationVo;
import com.ruoyi.scientific.domain.bo.ProjectApplicationBo;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 项目申报Service接口
 *
 * @author zhanli
 * @date 2024-07-18
 */
public interface IProjectApplicationService {

    /**
     * 查询项目申报
     */
    ProjectApplicationVo queryById(Long projectId);

    /**
     * 查询项目申报列表
     */
    TableDataInfo<ProjectApplicationVo> queryPageList(ProjectApplicationBo bo, PageQuery pageQuery);

    /**
     * 查询项目申报列表
     */
    List<ProjectApplicationVo> queryList(ProjectApplicationBo bo);

    /**
     * 新增项目申报
     */
    Boolean insertByBo(ProjectApplicationBo bo);

    /**
     * 修改项目申报
     */
    Boolean updateByBo(ProjectApplicationBo bo);

    /**
     * 修改项目预算审批流程
     */
    Boolean updateBudgetProc(ProjectApplicationBo bo);

    /**
     * 校验并批量删除项目申报信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 更新项目Id更新预算信息
     */
    Boolean updateBudgetInfoById(Long projectId, Long newProjectBudget);

    /**
     * 项目经费到账确认：项目经费到账情况（由财务根据实际情况进行填写）
     * @param fundsReceivedBo 项目到账情况描述类，包含项目Id,项目到账情况，项目到账备注
     * @author zhanli
     * TODO: 2024/7/24 前版本暂时没有加权限的限制以及人员的限制，后续需要加入
     */
    Boolean confirmFundsReceivedById(FundsReceivedBo fundsReceivedBo);
}
